import 'package:durt/src/hd_wallet.dart';
import 'package:durt/src/dewif.dart';
import 'package:durt/src/cesium_wallet.dart';

void main() {
  const String mnemonicLang = 'french';

  print('------------------\n HD Wallet example\n------------------\n');
  var mnemonic = generateMnemonic(lang: mnemonicLang);

  HdWallet _hdWallet = HdWallet.fromMnemonic(mnemonic, lang: mnemonicLang);
  Bip32KeyPair _key = Bip32KeyPair(
      signingKey: _hdWallet.rootSigningKey, verifyKey: _hdWallet.rootVerifyKey);

  Bip32KeyPair derivation0 = _hdWallet.derive(keys: _key, index: 0);
  String pubkey0 = _hdWallet.getPubkey(derivation0);

  String message = "blabla test";
  var signature = _hdWallet.sign(message, keypair: derivation0);
  bool isOK = _hdWallet.verifySign(message, signature, keypair: derivation0);

  print('Mnemonic: ' + mnemonic);
  print('Pubkey 0: ' + pubkey0);
  print('Is signature OK ? : ' + isOK.toString());

  print('\n------------------\n DEWIF example\n------------------\n');

  Dewif? _dewif = Dewif();
  var _dewifData = _dewif.generateDewif(mnemonic, 'ABCDE', lang: mnemonicLang);
  print(_dewifData);

  String? decryptedDewif;
  try {
    decryptedDewif =
        _dewif.mnemonicFromDewif(_dewifData, 'ABCDE', lang: mnemonicLang);
    print('Unlock: ' + decryptedDewif);
  } on ChecksumException {
    print('Bad secret code');
  } catch (e) {
    print(e);
  }

  print(
      '\n------------------\n Cesium wallet generation example\n------------------\n');

  var cesiumWallet = CesiumWallet('toto', 'tata'); // Cesium ID + Password

  var pubkey = cesiumWallet.getPubkey();
  print(pubkey);

  var signatureCesium = cesiumWallet.sign(message);
  bool isOKCesium = cesiumWallet.verifySign(message, signatureCesium);

  print(isOKCesium); //true
}
